---
layout: doc-page
title: "Dotty Documentation"
---

Dotty is the project name for technologies that are considered for inclusion in Scala 3. Scala has
pioneered the fusion of object-oriented and functional programming in a typed setting. Scala 3 will
be a big step towards realizing the full potential of these ideas. Its main objectives are to

- become more opinionated by promoting programming idioms we found to work well,
- simplify where possible,
- eliminate inconsistencies and surprising behaviors,
- build on strong foundations to ensure the design hangs well together,
- consolidate language constructs to improve the language’s consistency, safety, ergonomics, and performance.

In this documentation you will find information on how to use the Dotty compiler on your machine,
navigate through the code, setup Dotty with your favorite IDE and more!

Table of Contents
=================
{% assign titles = sidebar.titles %}
{% include "table-of-contents" %}
