---
layout: doc-page
title: 0.1.2 release notes
---

0.1.2 will be the first public release of Dotty.
Being the first one, these notes are incomplete.
This document is a work in progress until 0.1.2-final is released.
These notes are up-to-date based on 0.1.2-RC1 and will be updated
with changes that happen during the RC stabilization cycle.

# Required Java Version

Dotty 0.1.2 targets Java 8. We don't have plans to add support for earlier versions of Java.

# IDE support for Dotty

# Reporting Bugs / Known Issues

Please [file](https://github.com/lampepfl/dotty/issues) any bugs you encounter. If you’re unsure whether something is a bug,
please ask on the Dotty [gitter channel](https://github.com/lampepfl/dotty).

# Dotty Doc

Dotty has added support for Dotty Doc.
Actually, the dotty documentation site [https://dotty.epfl.ch/docs/](https://dotty.epfl.ch/docs/) is generated by it.
Looks nice, doesn’t it?

#Other implemented features:

This release ships with the following features:

 - TASTY support by [@odersky], [@xeno-by] and [@darkdimius] [\[1\]][1]
 - HK-types support by [@odersky], [@smarter] and [@darkdimius] [\[2\]][2]
 - Intersection and Union Types by [@odersky] [\[3\]][3] [\[4\]][3]
 - Enumerations by [@odersky] [\[4\]][4] [\[5\]][5] [\[6\]][6]
 - Implicit By-Name Parameters by [@odersky] [\[7\]][7]
 - Miniphases-based design by [@darkdimius], [@odersky] and [@olhotak] [\[8\]][8]
 - `@static` methods support by [@darkdmius] [\[9\]][9]
 - Non-blocking lazy vals by [@darkdimius] [\[10\]][10]
 - JVM code emission by [@magarciaEPFL] and [@darkdimius] [\[11\]][11]
 - Efficient multi-dimensional array allocation by [@darkdimius] [\[12\]][12]
 - Default-method based trait composition [@odersky] and [@darkdimius] [\[13\]][13] [\[14\]][14]
 - Trait parameters by [@odersky] [\[15\]][15]
 - Working contravariant implicits by [@odersky] [\[16\]][16]
 - Option-less pattern matching by [@odersky], [@darkdimius] and [@OlivierBlanvillain] [\[17\]][17]
 - SAM-based anonymous functions by [@magarciaEPFL], [@darkdimius] and [@retronym] [\[18\]][18]
 - Pattern matching support by [@darkdimius] [\[19\]][19]
 - Value classes support by [@smarter] and [@darkdimius] [\[20\]][20]
 - Pattern matching exhaustivity checks by [@liufengyun] [\[21\]][21]
 - Tailrec optimization by [@darkdimius] [\[22\]][22] [\[23\]][23]
 - Language server protocol implementation by [@smarter] [\[24\]][24]
 - VS code plugin by [@smarter] [\[24\]][24]
 - Vulpix: new test-suite driver by [@felixmulder] that replaces partest by [@vsalvis] [\[25\]][25]
 - Java parser by [@olhotak] [\[26\]][26]
 - Local optimizations(-optimise) by [@darkdimius] and [@OlivierBlanvillain] [\[27\]][27]
 - sbt support by [@smarter] [\[28\]][28]
 - DottyDoc by [@felixmulder] [\[29\]][29]
 - Implicit Function Types by [@odersky] [\[30\]][30]
 - Phantom Types by [@nicolasstucki] [\[31\]][31]
 - Functions with more than 22 parameters by [@odersky] [\[32\]][32]
 - Inline keyword by [@odersky] [\[33\]][33]

[@odersky]: https://twitter.com/odersky
[@DarkDimius]: https://twitter.com/DarkDimius
[@smarter]: https://github.com/smarter
[@felixmulder]: https://twitter.com/felixmulder
[@nicolasstucki]: https://github.com/nicolasstucki
[@liufengyun]: https://github.com/liufengyun
[@OlivierBlanvillain]: https://github.com/OlivierBlanvillain
[@olhotak]: https://plg.uwaterloo.ca/~olhotak/
[@retronym]: https://github.com/retronym
[@xeno-by]: https://github.com/xeno-by
[@vsalvis]: https://github.com/vsalvis
[@magarciaEPFL]: https://github.com/magarciaEPFL

[1]: https://docs.google.com/document/d/1h3KUMxsSSjyze05VecJGQ5H2yh7fNADtIf3chD3_wr0/edit
[2]: https://infoscience.epfl.ch/record/222780?ln=en
[3]: ../reference/new-types/intersection-types.html
[4]: ../reference/new-types/union-types.html
[5]: ../reference/enums/adts.html
[6]: ../reference/enums/desugarEnums.html
[7]: ../reference/other-new-features/implicit-by-name-parameters.html
[8]: https://infoscience.epfl.ch/record/228518
[9]: http://docs.scala-lang.org/sips/pending/static-members.html
[10]: http://docs.scala-lang.org/sips/pending/improved-lazy-val-initialization.html
[11]: http://magarciaepfl.github.io/scala/
[12]: https://github.com/lampepfl/dotty/commit/b2215ed23311b2c99ea638f9d7fcad9737dba588
[13]: https://github.com/lampepfl/dotty/pull/187
[14]: https://github.com/lampepfl/dotty/pull/217
[15]: ../reference/other-new-features/trait-parameters.html
[16]: https://github.com/lampepfl/dotty/commit/89540268e6c49fb92b9ca61249e46bb59981bf5a
[17]: https://github.com/lampepfl/dotty/pull/174
[18]: https://github.com/lampepfl/dotty/pull/488
[19]: https://github.com/lampepfl/dotty/pull/174
[20]: https://github.com/lampepfl/dotty/pull/411
[21]: https://github.com/lampepfl/dotty/pull/1364
[22]: https://github.com/lampepfl/dotty/pull/1227
[23]: https://github.com/lampepfl/dotty/pull/117
[24]: https://github.com/lampepfl/dotty/pull/2532
[25]: https://github.com/lampepfl/dotty/pull/2194
[26]: https://github.com/lampepfl/dotty/pull/213
[27]: https://github.com/lampepfl/dotty/pull/2513
[28]: https://github.com/lampepfl/dotty/pull/2361
[29]: https://github.com/lampepfl/dotty/pull/1453
[30]: ../reference/contextual/implicit-function-types.html
[31]: https://github.com/lampepfl/dotty/pull/2136
[32]: https://github.com/lampepfl/dotty/pull/1758
[33]: ../reference/metaprogramming/inline.html

# Contributors
The Dotty team and contributors have closed 750 issues and have merged a total of 1258 pull requests.

Concretely, according to

 ```
 git ls-tree -r -z --name-only HEAD -- |egrep -z -Z -E '\.(scala)$'| xargs -0 -n1 git blame --line-porcelain |grep "^author "|sort|uniq -c|sort -nr
 ```
71 people contributed code, tests, and/or documentation to Dotty 0.1.2-RC1.
The following people have contributed to this release:

| commits | blame lines | Name                        |
|---------|-------------|-----------------------------|
| 4346    | 82017       | Martin Odersky              |
| 1288    | 83070       | Dmitry Petrashko            |
| 19      | 35382       | Samuel Gruetter             |
| 826     | 20148       | Felix Mulder                |
| 567     | 10454       | Guillaume Martres           |
| 136     | 5311        | liu fengyun                 |
| 189     | 4449        | Nicolas Stucki              |
| 21      | 3717        | Sébastien Doeraene          |
| 30      | 1711        | Ondrej Lhotak               |
| 33      | 1094        | Enno Runne                  |
| 47      | 735         | Olivier Blanvillain         |
| 4       | 480         | Valthor Halldorsson         |
| 7       | 343         | Aleksander Boruch-Gruszecki |
| 25      | 220         | VladimirNik                 |
| 3       | 186         | Enno                        |
| 8       | 143         | Clemens Winter              |
| 16      | 133         | Jason Zaugg                 |
| 3       | 116         | Miron Aseev                 |
| 4       | 109         | Shane Delmore               |
| 5       | 100         | Alexander Myltsev           |
| 5       | 96          | Abel Nieto                  |
| 1       | 92          | Dmitry Melnichenko          |
| 22      | 88          | Jonathan Brachthäuser       |
| 5       | 87          | Guillaume Massé             |
| 20      | 75          | vsalvis                     |
| 2       | 64          | Tobias Schlatter            |
| 4       | 51          | Ólafur Páll Geirsson        |
| 4       | 49          | Sebastian Harko             |
| 2       | 48          | Andrew Zurn                 |
| 3       | 44          | jvican                      |
| 1       | 43          | Jarrod Janssen              |
| 1       | 43          | Igor Mielientiev            |
| 2       | 35          | Thiago Pereira              |
| 5       | 32          | Martijn Hoekstra            |
| 1       | 26          | Bartosz Krasiński           |
| 1       | 24          | Adam Trousdale              |
| 10      | 22          | Aggelos Biboudis            |
| 12      | 20          | Paolo G. Giarrusso          |
| 1       | 17          | Jon-Anders Teigen           |
| 17      | 16          | Vlad Ureche                 |
| 1       | 16          | Jyotman Singh               |
| 4       | 15          | Lucas Burson                |
| 1       | 12          | Markus Hauck                |
| 3       | 11          | Varunram Ganesh             |
| 2       | 11          | Reto Hablützel              |
| 3       | 10          | Allan Renucci               |
| 4       | 9           | Sarunas Valaskevicius       |
| 2       | 9           | Nikolay.Tropin              |
| 1       | 9           | Csongor Kiss                |
| 2       | 7           | dos65                       |
| 2       | 6           | Varunram                    |
| 6       | 5           | Nada Amin                   |
| 1       | 4           | ruben                       |
| 1       | 4           | Kazuyoshi Kato              |
| 1       | 3           | Jonathan Rodriguez          |
| 1       | 3           | andreaTP                    |
| 1       | 1           | AlexSikia                   |
| 3       | 0           | Edmund Noble                |
| 2       | 0           | jvican                      |
| 3       | 0           | Allan Renucci               |
| 3       | 0           | Senia-psm                   |
| 2       | 0           | Lukas Rytz                  |
| 2       | 0           | Jan Christopher Vogt        |
| 2       | 0           | Raymond Tay                 |
| 1       | 0           | Matthias Sperl              |
| 1       | 0           | Herdy Handoko               |
| 1       | 0           | Grzegorz Kossakowski        |
| 1       | 0           | George Leontiev             |
| 1       | 0           | Sandro Stucki               |
| 1       | 0           | Adriaan Moors               |
| 1       | 0           | Simon Hafner                |
